]> de.git.xonotic.org Git - xonotic/xonotic-data.pk3dir.git/blob - .gitlab-ci.yml
Cut off long names in the duel centerprint title (same scoreboard limit)
[xonotic/xonotic-data.pk3dir.git] / .gitlab-ci.yml
1 workflow:\r
2   rules:\r
3     - if: $CI_COMMIT_MESSAGE =~ /Transifex autosync/\r
4       when: never\r
5     - when: always\r
6 \r
7 before_script:\r
8   - ln -s $PWD data/xonotic-data.pk3dir\r
9 \r
10   - export MAKEFLAGS=-j$(nproc); echo MAKEFLAGS=$MAKEFLAGS\r
11 #   FIXME: -march=native -mtune=native _changes the hash_, why?!?\r
12 # - export CC="gcc -pipe -march=native -mtune=native"\r
13   - export CC="gcc -pipe"\r
14 \r
15   - git clone --depth=1 --branch=main https://gitlab.com/xonotic/gmqcc.git gmqcc\r
16   - make -C gmqcc || exit 1\r
17   - export QCC="$PWD/gmqcc/gmqcc"\r
18 \r
19   # Makefile: don't complain about lack of tags (fetching them is slow)\r
20   - export QCCFLAGS_WATERMARK=gitlab_pipeline\r
21   # Makefile: don't compress anything or complain about lack of zip program\r
22   - export ZIP=/bin/true\r
23 \r
24 test_compilation_units:\r
25   rules:\r
26     - changes:\r
27       - qcsrc/**/*\r
28   stage: test\r
29   script:\r
30     - make test\r
31 \r
32 test_sv_game:\r
33   stage: test\r
34   script:\r
35     - git clone --depth=1 --branch=div0-stable https://gitlab.com/xonotic/darkplaces.git darkplaces\r
36     - make -C darkplaces sv-release || exit 1\r
37     - export ENGINE="$PWD/darkplaces/darkplaces-dedicated -xonotic -noconfig -nohome"\r
38     - make qc || exit 1\r
39 \r
40     - mkdir -p data/maps\r
41     - wget -O data/maps/gitlab-ci.bsp https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/_init/_init.bsp\r
42 \r
43     - while read LINE; do\r
44         echo $LINE;\r
45         [ "$LINE" = "All tests OK" ] && PASS=1;\r
46       done < <(${ENGINE} +developer 1 +map gitlab-ci +sv_cmd runtest +wait +quit)\r
47     - test "$PASS" = "1" || { echo 'sv_cmd runtest failed!'; exit 1; }\r
48 \r
49     - ${ENGINE} +map gitlab-ci +sv_cmd dumpnotifs +wait +quit\r
50     - diff notifications.cfg data/data/notifications_dump.cfg ||\r
51         { echo 'Please update notifications.cfg using `dumpnotifs`!'; exit 1; }\r
52 \r
53     - wget -O data/stormkeep.pk3 http://beta.xonotic.org/autobuild-bsp/latest/stormkeep.pk3\r
54     - wget -O data/maps/stormkeep.mapinfo https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.mapinfo\r
55     - wget -O data/maps/stormkeep.waypoints https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints\r
56     - wget -O data/maps/stormkeep.waypoints.cache https://gitlab.com/xonotic/xonotic-maps.pk3dir/raw/master/maps/stormkeep.waypoints.cache\r
57 \r
58     - EXPECT=8e36763a3b4590356bcc449b2452d0ea\r
59     - HASH=$(${ENGINE} +timestamps 1 +exec serverbench.cfg\r
60       | tee /dev/stderr\r
61       | sed -e 's,^\[[^]]*\] ,,'\r
62       | grep '^:'\r
63       | grep -v '^:gamestart:'\r
64       | grep -v '^:anticheat:'\r
65       | md5sum | awk '{ print $1 }')\r
66     - echo 'expected:' $EXPECT\r
67     - echo '  actual:' $HASH\r
68     - test "$HASH" == "$EXPECT"\r
69     - exit $?\r
70 \r
71 \r
72 # NOTE: The generated docs are incomplete - they don't contain code behind SVQC CSQC MENUQC GAMEQC ifdefs.\r
73 # With them added to PREDEFINED, it would take over half an hour to generate the docs and even then\r
74 # they might not be complete. Doxygen doesn't handle #elif and might not understand some QC definitions.\r
75 #doxygen:  # rename to 'pages' when gitlab.com allows pages to exceed 100MiB\r
76 #  before_script:\r
77 #    - ln -s $PWD data/xonotic-data.pk3dir # is this needed?\r
78 #    - apt-get update\r
79 #    - apt-get -y install doxygen graphviz\r
80 #  stage: deploy\r
81 #  script:\r
82 #    - cd qcsrc && doxygen\r
83 #    - mv html ../public\r
84 #    - mkdir -p ~/.ssh\r
85 #    - for i in {0..0}; do eval $(printf "echo \$id_rsa_%02d\n" $i) >> ~/.ssh/id_rsa_base64; done\r
86 #    - base64 --decode ~/.ssh/id_rsa_base64 > ~/.ssh/id_rsa\r
87 #    - chmod 600 ~/.ssh/id_rsa\r
88 #    - echo -e "Host *\n\tStrictHostKeyChecking no\n\tLogLevel ERROR\n" >> ~/.ssh/config\r
89 #    - git config --global user.name "Gitlab CI"\r
90 #    - git config --global user.email "<>"\r
91 #    - git clone --single-branch --depth 1 ${DEPLOY_HOST}:${DEPLOY_REPO} ~/deploy_\r
92 #    - mkdir ~/deploy && mv ~/deploy_/.git ~/deploy && rm -r ~/deploy_\r
93 #    - cp -r ../public/* ~/deploy\r
94 #    - cd ~/deploy && git add -A . && git commit -m "Deploy ${CI_BUILD_REF}" && git push origin gh-pages\r
95 #  artifacts:\r
96 #    paths:\r
97 #      - public\r
98 #  only:\r
99 #    - master\r